package com.sailpoint.plugin.exampleplugin.rest;

import java.sql.SQLException;
import java.text.ParseException;
import java.util.Map;


import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import sailpoint.object.*;
import sailpoint.api.*;
import sailpoint.rest.plugin.BasePluginResource;
import sailpoint.rest.plugin.RequiredRight;
import sailpoint.tools.GeneralException;

import javax.ws.rs.*;
import javax.ws.rs.core.Response;

/**
 * @author Adam Creaney
 * 
 *         Class to manage all rest api calls.
 */
@Path("PluginExample")
@Consumes("application/json")
@Produces("application/json")
@RequiredRight("examplePluginRight")
public class ExamplePluginRestManager extends BasePluginResource {
	
	private static final Log	log	= LogFactory.getLog(ExamplePluginRestManager.class);
	private Response			response;
	
	public String getPluginName() {
		
		return "Example Plugin";
	}

	
	@GET
	@Path("getExample")
	public Response getExample() throws GeneralException, SQLException {
		
		log.trace("Entering getExample...");
		SailPointContext context = SailPointFactory.getCurrentContext();

		QueryOptions qo = new QueryOptions();
		Filter filter = Filter.eq("name", "vpq888");
		qo.addFilter(filter);
		int count = context.countObjects(Identity.class, qo);

		String responseString = "How many Adams? " + count;
		response = Response.status(Response.Status.OK).entity(responseString).build();

		log.trace("Exiting getExample...");

		return response;
	}
	
	@POST
	@Path("postExample")
	public Response postExample(Map<String, Object> request) throws GeneralException, SQLException, ParseException {
		log.trace("Entering postExample...");


		log.trace("Exiting postExample...");
		
		return response;
	}

	/*		QueryOptions qo = new QueryOptions();
		Filter filter = Filter.eq("name", "Adam.Kennedy");
		qo.addFilter(filter);

		int adams = context.countObjects(Identity.class, qo);
		String responseString = "I found some Adams: " + adams;
	*/
}
